//
//  AppDelegate.m
//  GL_Shippy
//
//  Created by Giles Williams on Fri Oct 10 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//
#include <sys/time.h>

#import "AppDelegate.h"
#import "Universe.h"

@implementation AppDelegate

- (void) setGameView:(NSView *)view
{
    if (gameView)	[gameView release];
    gameView = view;
    [gameView retain];
	if (universe)   [universe setGameView:gameView];
}

- (void) updateTiming
{
    NSDate	*now = [NSDate date];
    NSTimeInterval	ti;
    if (old_time)
    {
        ti = [now timeIntervalSinceDate:old_time];
        [old_time release];
        delta_t = ti;
    }
    old_time = [now retain];
}

- (Universe *) universe
{
    return universe;
}

- (void) setUniverse:(Universe *) theUniverse
{
    if (universe)	[universe release];
    universe = theUniverse;
    [universe retain];
	if (gameView)   [universe setGameView:gameView];
}

- (id) init
{
    self = [super init];
    //
    //universe = [[Universe alloc] init];
    delta_t = 0.02; // one hundredth of a second
    //
    return self;
}

- (void) dealloc
{
    if (timer)		[timer release];
    if (runloop)	[runloop release];
    if (modes)		[modes release];
    if (gameView)	[gameView release];
    if (universe)	[universe release];
    if (old_time)	[old_time release];
    [super dealloc];
}

- (void) applicationWillFinishLaunching: (NSNotification*) notification
{
}

- (void) applicationDidFinishLaunching: (NSNotification*) notification
{
    //
    // get the run loop and add the call to doStuff
    //
    NSTimeInterval ti = 0.01;
    
    timer = [[NSTimer timerWithTimeInterval:ti target:self selector:@selector(doStuff:) userInfo:self repeats:YES] retain];

    modes = [[NSArray arrayWithObject:NSDefaultRunLoopMode] retain];
    runloop = [[NSRunLoop currentRunLoop] retain];
    
    [runloop addTimer:timer forMode:NSDefaultRunLoopMode];

    // moved here to try to avoid initialising this before having an Open GL context
    universe = [[Universe alloc] init];

    //[runloop performSelector:@selector(doStuff:) target:self argument:runloop order:0 modes:modes];
    //
}

- (void) applicationWillTerminate: (NSNotification*) notification
{
//	stuff
}

- (void) doStuff: (id) sender
{
    [self updateTiming];
    
    if (universe)
    {
        [universe update:delta_t];
        //NSLog(@"universe update called : delta_t %f",(float)delta_t);

    }
    if (gameView)
    {
        [gameView display];
        //NSLog(@"gameView display called : delta_t %f",(float)delta_t);
    }
    else
    {
        NSLog(@"gameView not set : delta_t %f",(float)delta_t);
    }
    
    // do it again!
    //
    //[runloop performSelector:@selector(doStuff:) target:self argument:runloop order:-9999 modes:modes];

}

@end
