/* GameController
 *
 *  Oolite
 *
 *  Created by Giles Williams on Sat Apr 03 2004.
 *  Copyright (c) 2004 for aegidian.org. All rights reserved.
 *

Copyright (c) 2004, Giles C Williams
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

   Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

   Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or other
materials provided with the distribution.

   Neither the name of aegidian.org nor the names of its contributors may be used
to endorse or promote products derived from this software without specific prior
written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.

*/


#import <Cocoa/Cocoa.h>



#define MODE_WINDOWED		100
#define MODE_FULL_SCREEN	200


@class Universe, MyOpenGLView, TextureStore;

@interface GameController : NSObject
{
    IBOutlet MyOpenGLView   *gameView;
    IBOutlet NSWindow		*gameWindow;

    Universe	*universe;
    NSDate		*old_time;
    double		delta_t;
    
	int		my_mouse_x, my_mouse_y;
	
	CGMouseDelta mouse_dx, mouse_dy;
	
	NSString	*playerFileToLoad;
	
    NSTimer		*timer;
	
	/*  GDC example code */
	
    NSMutableArray         *displayModes;

    unsigned int  width, height;
    unsigned int  colorBits;
    unsigned int  depthBits;
    unsigned int  refresh;
    BOOL          fullscreen;
    NSDictionary *originalDisplayMode;
    NSDictionary *fullscreenDisplayMode;
	
    NSOpenGLContext *fullScreenContext;
	
	BOOL		stayInFullScreenMode;

	/*  end of GDC */
	
	TextureStore	*oldTextureStore;
	
	SEL			pauseSelector;
	id			pauseTarget;
	
}

- (IBAction) goFullscreen:(id) sender;
- (void) exitFullScreenMode;
- (BOOL) inFullScreenMode;

- (void) pauseFullScreenModeToPerform:(SEL) selector onTarget:(id) target;
- (void) exitApp;

- (BOOL) setDisplayWidth:(unsigned int) d_width Height:(unsigned int)d_height Refresh:(unsigned int) d_refresh;
- (NSDictionary *) findDisplayModeForWidth:(unsigned int)d_width Height:(unsigned int) d_height Refresh:(unsigned int) d_refresh;
- (NSArray *) displayModes;
- (int) indexOfCurrentDisplayMode;

- (void) getDisplayModes;

- (void) updateTiming;
- (void) doStuff: (id)sender;

- (void) startAnimationTimer;
- (void) stopAnimationTimer;

- (MyOpenGLView *) gameView;
- (void) setGameView:(NSView *)view;
- (Universe *) universe;
- (void) setUniverse:(Universe *) theUniverse;

- (void) resizeWindow:(NSSize) size;

@end
