//
//  GuiDisplayGen.h
/*
 *
 *  Oolite
 *
 *  Created by Giles Williams on Sat Apr 03 2004.
 *  Copyright (c) 2004 for aegidian.org. All rights reserved.
 *

Copyright (c) 2004, Giles C Williams
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

•   Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

•   Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or other
materials provided with the distribution.

•   Neither the name of aegidian.org nor the names of its contributors may be used
to endorse or promote products derived from this software without specific prior
written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.

*/

#import <Cocoa/Cocoa.h>

#define GUI_MAX_ROWS			24
#define GUI_MAX_COLUMNS			6
#define GUI_PIXEL_HEIGHT		480
#define GUI_PIXEL_WIDTH			480
#define GUI_PIXEL_ROW_CENTER	(GUI_PIXEL_WIDTH/2)
#define GUI_PIXEL_ROW_HEIGHT	16
#define GUI_PIXEL_ROW_START		40
#define GUI_PIXEL_TITLE_HEIGHT  24

#define GUI_ALIGN_LEFT			0
#define GUI_ALIGN_RIGHT			1
#define GUI_ALIGN_CENTER		2


#import "OpenGLSprite.h"

@interface GuiDisplayGen : NSObject {

	NSSound			*guiclick;

	NSImage			*image;
	OpenGLSprite	*openGLSprite;
	
	NSString		*title;
	
	NSMutableArray  *rowText;
	NSMutableArray  *rowKey;
	NSMutableArray  *rowColor;
	
	NSPoint			rowPosition[GUI_MAX_ROWS];
	int				rowAlignment[GUI_MAX_ROWS];
	
	int				tabStops[GUI_MAX_COLUMNS];
	
	NSRange			rowRange;

	int				selectedRow;
	NSRange			selectableRange;
	
}

- (void) click;

- (void) setColor:(NSColor *) color forRow:(int) row;

- (id) objectForRow:(int) row;
- (int) selectedRow;
- (BOOL) setSelectedRow:(int) row;
- (void) setNoSelectedRow;
- (NSString *) selectedRowText;
- (NSString *) selectedRowKey;

- (NSRange) selectableRange;
- (void) setSelectableRange:(NSRange) range;

- (void) setTabStops:(int *)stops;

- (void) clear;

- (void) setTitle: (NSString *) str;

- (void) setKey: (NSString *) str forRow:(int) row;
- (void) setText: (NSString *) str forRow:(int) row;
- (void) setText: (NSString *) str forRow:(int) row align:(int) alignment;
- (int) addLongText: (NSString *) str startingAtRow:(int) row align:(int) alignment;
- (void) setArray: (NSArray *) arr forRow:(int) row;

/////////////////////////////////////////////////////

- (id) init;
- (void) dealloc;

- (NSImage *) generateDisplay;

- (void) updateGui;

- (OpenGLSprite *) openGLSprite;

@end
